<template>
  <div class="page-wrapper" :class="themeClasses">
    <restaurant-header
      :loading="loading"
      :restaurant="restaurant"
      :groupId="groupId"
    />

    <div class="container">
      <div class="row justify-content-end">
        <div class="col-12 col-md-9">
          <ul class="restaurant-detail-list reset-list">
            <li>
              <div
                class="restaurant-detail-section-title content-large d-none d-md-block"
              >
                {{ $t("bookingForm.title") }}
              </div>
              <div class="restaurant-detail-content">
                <div v-show="!reservationId" class="reservation-form">
                  <div class="loading" v-if="loading">
                    <div class="lp md mb-3"></div>
                    <div class="lp sm mb-3"></div>
                    <div class="lp lg mb-3"></div>
                  </div>
                  <template v-else>
                    <div class="account-info-container">
                      <hello-member />
                    </div>

                    <div class="form-group">
                      <label class="booking-form-label">{{
                        $t("bookingForm.info")
                      }}</label>
                      <dl class="reservation-info-list content-small">
                        <dt>{{ $t("bookingForm.numOfPersons") }}</dt>
                        <dd>
                          {{
                            $t("bookingForm.nAdultNKid", {
                              adult: groupSize,
                              kid: numberOfKidChairs
                            })
                          }}
                        </dd>
                        <dt>{{ $t("bookingForm.date") }}</dt>
                        <dd>{{ date | dateWithWDay }}</dd>
                        <dt>{{ $t("bookingForm.time") }}</dt>
                        <dd>{{ time }}</dd>
                      </dl>
                    </div>

                    <template v-if="edit">
                      <div class="form-group">
                        <label class="booking-form-label"
                          >{{ $t("bookingForm.name") }}*</label
                        >
                        <div class="form-control-wrapper form-max-width">
                          <input
                            v-model="customerName"
                            type="text"
                            class="form-control"
                            :placeholder="$t('bookingForm.namePlaceholder')"
                          />
                          <div class="picker-control-wrapper">
                            <select
                              tabindex="-1"
                              v-model.number="gender"
                              class="picker-control"
                            >
                              <option value="0">{{
                                $t("bookingForm.gender.mr")
                              }}</option>
                              <option value="1">{{
                                $t("bookingForm.gender.miss")
                              }}</option>
                            </select>
                          </div>
                        </div>
                      </div>

                      <div class="form-group">
                        <label class="booking-form-label">
                          {{ $t("bookingForm.phone") }}*
                        </label>
                        <div class="form-control-wrapper form-max-width">
                          <input
                            v-model="phone"
                            type="tel"
                            class="form-control"
                            :placeholder="$t('bookingForm.phonePlaceholder')"
                          />
                          <span
                            class="form-text text-muted booking-phone-desc"
                            >{{ $t("bookingForm.phoneHint") }}</span
                          >
                        </div>
                      </div>
                    </template>
                    <!--
                    <template v-else>
                      <div class="form-group">
                        <label class="booking-form-label">{{ $t('bookingForm.customerInfo') }}</label>
                        <dl class="reservation-info-list content-small">
                          <dt>{{ $t('bookingForm.name') }}</dt>
                          <dd><strong>{{ account.name }}</strong></dd>
                          <dt>{{ $t('bookingForm.phone') }}</dt>
                          <dd><strong>{{ account.phoneNumber }}</strong></dd>
                        </dl>
                        <button @click.prevent.stop="editContact()" class="edit-button">{{ $t('bookingForm.editContactInfo') }}</button>
                      </div>
                    </template>
                    -->

                    <div class="form-group">
                      <label class="booking-form-label">{{
                        $t("bookingForm.purpose")
                      }}</label>
                      <div class="purpose-list content-small">
                        <div
                          class="purpose-item"
                          v-for="(p, i) in purposeItemEnum"
                          :key="i"
                        >
                          <input
                            :id="`purpose-${p}`"
                            class="form-checkbox"
                            name="purpose"
                            v-model="purpose"
                            type="radio"
                            :value="p"
                          />
                          <label
                            :for="`purpose-${p}`"
                            class="form-checkbox-label"
                            >{{ $t(`bookingForm.purposes.${p}`) }}</label
                          >
                        </div>
                      </div>
                    </div>

                    <div class="form-group">
                      <label class="booking-form-label">{{
                        $t("bookingForm.note")
                      }}</label>
                      <textarea
                        rows="5"
                        class="form-control"
                        v-model="customerNote"
                        :placeholder="$t('bookingForm.notePlaceholder')"
                      ></textarea>
                    </div>

                    <div v-if="numberOfKidChairs > 0" class="form-group">
                      <label class="booking-form-label">{{
                        $t("bookingForm.additionalRequirement")
                      }}</label>
                      <div>
                        <div class="requirement-list content-small">
                          <div
                            class="requirement-item"
                            v-if="!restaurant.webKidChairsSelectorHidden"
                          >
                            <input
                              id="ar-kidSet"
                              value="kidSet"
                              v-model="additionalRequirements"
                              name="ar"
                              class="form-checkbox"
                              type="checkbox"
                            />
                            <label
                              for="ar-kidSet"
                              class="form-checkbox-label"
                              >{{
                                $t(`bookingForm.additionalRequirements.kidSet`)
                              }}</label
                            >

                            <select
                              v-model="$data['numberOfKidSets']"
                              class="picker-control"
                            >
                              <option
                                :value="i"
                                v-for="(i, k) in numberOfKidChairs"
                                :key="k"
                                >{{ i }}</option
                              >
                            </select>
                            <span>{{
                              $t(
                                `bookingForm.additionalRequirements.kidSetUnit`
                              )
                            }}</span>
                          </div>

                          <div class="requirement-item">
                            <input
                              id="ar-pram"
                              value="pram"
                              v-model="additionalRequirements"
                              name="ar"
                              class="form-checkbox"
                              type="checkbox"
                            />
                            <label for="ar-pram" class="form-checkbox-label">{{
                              $t(`bookingForm.additionalRequirements.pram`)
                            }}</label>

                            <select
                              v-model="$data['pram']"
                              class="picker-control"
                            >
                              <option :value="i" v-for="(i, k) in 5" :key="k">{{
                                i
                              }}</option>
                            </select>
                            <span>{{
                              $t(`bookingForm.additionalRequirements.pramUnit`)
                            }}</span>
                          </div>

                          <span
                            class="c-secondary-black requirement-item-desc"
                            >{{
                              $t("bookingForm.additionalRequirements.hint")
                            }}</span
                          >
                        </div>
                      </div>
                    </div>

                    <div class="sorry-box" v-if="errorData">
                      {{
                        errorData.code
                          ? $t(`errorCodes.${errorData.code}`)
                          : errorData.reason
                      }}
                    </div>
                    <div
                      class="flex flex-column items-center text-center form-actions"
                    >
                      <button
                        @click="submit"
                        class="skm-btn skm-primary-btn"
                        :class="{
                          disabled: !paramsAllPresent,
                          active: submitting
                        }"
                      >
                        {{ $t("actions.submit") }}
                      </button>
                      <router-link
                        @click.native="mixpanelTrack('Back')"
                        :to="{
                          name: 'RestaurantBooking',
                          query: { groupSize, numberOfKidChairs, date, time }
                        }"
                        class="skm-btn skm-secondary-btn"
                        >{{ $t("actions.back") }}</router-link
                      >
                    </div>
                  </template>
                </div>
                <div
                  v-show="reservationId"
                  class="reservation-result text-center"
                  :class="themeClasses"
                >
                  <div class="result-title title-lg">
                    {{ $t("bookingForm.result.success") }}
                  </div>
                  <p class="result-message">
                    {{ $t("bookingForm.result.smsToPhone", { phone: phone }) }}
                  </p>
                  <a
                    @click="mixpanelTrackSuccessDetails('Enter')"
                    :href="reservationLink"
                    target="_blank"
                    class="skm-btn skm-primary-btn"
                    >{{ $t("actions.viewReservation") }}</a
                  ><br />
                  <a href="/" class="skm-btn skm-secondary-btn">{{
                    $t("actions.backToFoodMap")
                  }}</a>
                </div>
              </div>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { mapState, mapGetters, mapActions, mapMutations } from "vuex";
import moment from "moment";
import RestaurantHeader from "@/components/Restaurant/Header";
import * as Api from "@/api";
import _ from "underscore";
import Cookies from "js-cookie";
import { GENDER_MALE } from "@/models/account";
import HelloMember from "@/components/HelloMember";

const RESERVATION_COOKIE_KEY = "reservation";

export default {
  components: {
    RestaurantHeader,
    HelloMember
  },
  props: {
    id: {
      required: true
    },
    groupId: {
      required: true
    },
    companyId: {
      required: true
    },
    groupSize: {
      required: true
    },
    numberOfKidChairs: {
      required: true
    },
    vipSlot: {
      default: "0"
    },
    date: {
      type: String,
      required: true
    },
    time: {
      type: String,
      required: true
    }
  },
  data() {
    const lastReservation = this.getReservationData();

    const data = {
      edit: false,
      purposeItemEnum: [
        "celebration",
        "dating",
        "annualSale",
        "family",
        "friend",
        "business"
      ],
      newCustomerName: "",
      newGender: 0,
      newPhone: "",
      purpose: "",
      customerNote: "",
      additionalRequirements: [],
      pram: 1,
      numberOfKidSets: 1,
      submitting: false,
      // Success
      reservationId: null,
      reservationLink: null,
      // Failure
      errorData: null,
      ...lastReservation
    };

    delete data.gender;
    delete data.customerName;
    delete data.phone;

    return data;
  },

  computed: {
    ...mapState("restaurant", ["restaurant", "loading"]),
    ...mapState(["locale"]),
    ...mapState("account", ["account"]),
    ...mapGetters("theme", ["themeClasses"]),
    ...mapGetters("account", ["isVipMember"]),

    accountLoading() {
      return this.$store.state.account.loading;
    },

    phone: {
      get() {
        return this.edit
          ? this.newPhone
          : this.account
          ? this.account.phoneNumber
          : "";
      },

      set(val) {
        this.newPhone = val;
      }
    },

    gender: {
      get() {
        return this.edit
          ? this.newGender
          : this.account && this.account.genderType === GENDER_MALE
          ? 0
          : 1;
      },

      set(val) {
        this.newGender = val;
      }
    },

    customerName: {
      get() {
        var name = this.account ? this.account.name : "";
        if (this.isVipMember) {
          name = name[0];
        }
        return this.edit ? this.newCustomerName : name;
      },

      set(val) {
        this.newCustomerName = val;
      }
    },

    paramsAllPresent() {
      return this.phone && this.customerName;
    },

    note() {
      const notes = [];
      if (this.additionalRequirements.indexOf("pram") !== -1) {
        notes.push(`嬰兒車:${this.pram}`);
      }
      if (this.purpose) {
        notes.push(
          `用餐目的:${this.$t(`bookingForm.purposes.${this.purpose}`)}`
        );
      }
      return notes.join("\n");
    },

    datetime() {
      return moment(
        `${this.date} ${this.time}`,
        "YYYY-MM-DD HH:mm"
      ).toISOString();
    },

    reservation() {
      const {
        customerName,
        gender,
        phone,
        numberOfKidChairs,
        groupSize,
        customerNote,
        note,
        datetime,
        additionalRequirements,
        vipSlot
      } = this;

      const numberOfKidSets =
        additionalRequirements.indexOf("kidSet") !== -1
          ? this.numberOfKidSets
          : 0;

      return {
        customerName,
        gender,
        phone,
        language: this.locale,
        groupSize: Number(groupSize),
        numberOfKidChairs: Number(numberOfKidChairs) - numberOfKidSets,
        numberOfKidSets: Number(numberOfKidSets),
        customerNote,
        note,
        datetime,
        vipSlot
      };
    }
  },
  watch: {
    reservation() {
      this.saveReservationData();
    },

    account() {
      this.edit = false;
      this.editContact();
    },

    accountLoading(val) {
      if (!val && !this.account) {
        this.$router.push({ name: "RestaurantBooking" });
      }
    }
  },
  methods: {
    ...mapActions("restaurant", ["clearReservation"]),
    ...mapMutations("restaurant", ["setRestaurant"]),

    editContact() {
      // eslint-disable-next-line no-self-assign
      this.gender = this.gender;
      // eslint-disable-next-line no-self-assign
      this.customerName = this.customerName;
      // eslint-disable-next-line no-self-assign
      this.phone = this.phone;
      this.edit = true;
    },
    resetReservationData() {
      Cookies.remove(RESERVATION_COOKIE_KEY);
    },
    getReservationData() {
      return JSON.parse(Cookies.get(RESERVATION_COOKIE_KEY) || "{}");
    },
    saveReservationData() {
      const dataToStore = _.pick(
        this,
        "customerName",
        "gender",
        "phone",
        "purpose",
        "customerNote",
        "additionalRequirements",
        "pram",
        "numberOfKidSets"
      );
      Cookies.set(RESERVATION_COOKIE_KEY, JSON.stringify(dataToStore));
    },
    fetchRestaurant() {
      const { groupId, companyId, id } = this;
      return this.$store.dispatch("restaurant/fetchRestaurant", {
        groupId,
        companyId,
        id,
        params: { language: this.locale }
      });
    },
    submit() {
      this.mixpanelTrack("Submit");
      this.errorData = null;
      this.submitting = true;
      const account = {
        MemberID: this.account.id,
        MemberLevel: this.account.realLevel,
        MemberEmail: "",
        MemberAddress: "",
        MemberBirthday: ""
      };

      try {
        const result = Api.Reservation.createBooking(
          this.restaurant,
          this.reservation,
          account
        );

        result.then(res => {
          const { reservationId = "", reservationLink = "" } = res;
          this.reservationId = reservationId;
          this.reservationLink = reservationLink;
          this.mixpanelTrack("Succeed");
          this.resetReservationData();

          window.gtag("event", `pageview`, {
            event_category: "美食地圖餐廳訂位完成",
            event_label: JSON.stringify({
              category: [
                this.restaurant.groupName,
                this.restaurant.buildingName,
                this.restaurant.floor
              ].join(" - "),
              value: this.restaurant.company.name,
              content: this.groupSize + this.numberOfKidChairs,
              time: this.datetime,
              goal: this.purpose
                ? this.$t(`bookingForm.purposes.${this.purpose}`)
                : null,
              remark: this.customerNote
            })
          });
          this.submitting = false;
        });
      } catch (err) {
        this.errorData = err.response.data;
      }
    },
    mixpanelTrack(event) {
      window.gtag("event", `Booking process - ${event}`, {
        event_label: JSON.stringify({
          ...this.restaurant.dataForMixpanel
        })
      });
    },
    mixpanelTrackSuccessDetails(event) {
      window.gtag("event", `Success details - ${event}`, {
        event_label: JSON.stringify({
          ...this.restaurant.dataForMixpanel
        })
      });
    }
  },
  mounted() {
    this.setRestaurant(undefined);
    this.fetchRestaurant().then(() => {
      this.mixpanelTrack("Enter");
    });
    this.editContact();
  },
  destroyed() {
    this.clearReservation();
    this.setRestaurant(undefined);
  }
};
</script>
<style lang="scss" scoped>
.page-wrapper.theme-vip-member {
  background: $color-gold-100;
  margin-bottom: 40px;
}

.reservation-form {
  margin: $grid-gutter-width $grid-gutter-width * 1.5 $grid-gutter-width * 1.5;
  @include media-breakpoint-up(md) {
    background-color: $color-white;
    margin: 0;
    padding: 40px 65px;
  }
}

// Step 2
.reservation-info-list {
  background-color: $color-genesis-white;
  padding: 10px 20px;
  align-items: center;
  display: flex;
  flex-flow: row wrap;
  width: 100%;

  // basis(dt) + basis(dd) should greater than 75%
  dt {
    flex: 1 1 25%;
    font-weight: normal;
  }
  dd {
    flex: 1 1 51%;
    text-align: right;
    padding: 7.5px 0;
    margin-bottom: 0;
  }

  @include media-breakpoint-up(md) {
    margin: 0;
    font-size: 18px;
  }
}

.theme-vip-member .reservation-info-list {
  background: $color-gold-100;
  border: 2px $color-skm-gold solid;
}

.purpose-list {
  display: flex;
  flex-flow: row wrap;

  @include media-breakpoint-up(md) {
    font-size: 16px;
    max-width: 480px;
  }
}

.purpose-item {
  flex: 0 1 33.3%;
  box-sizing: border-box;
  padding-right: 0.5em;
  color: $color-secondary-black;
}

.purpose-item .form-checkbox-label:before {
  top: 0.75em;
}

.purpose-item .form-checkbox-label {
  margin-bottom: 17px;
}

.requirement-list {
  max-width: 300px;
  @include media-breakpoint-up(md) {
    font-size: 16px;
    max-width: 350px;
  }
}

.requirement-item {
  flex: 0 1 auto;
  margin-bottom: 0.75em;
  height: 32px;
  display: flex;
  align-items: center;
  color: $color-secondary-black;
  .form-checkbox-label {
    margin-bottom: 0;
  }
}

.skm-secondary-btn {
  margin-top: $grid-gutter-width/2;
}

.form-checkbox-label + .picker-control {
  display: inline-block;
  width: auto;
  padding: 0 0.75em;
  height: 32px;
  line-height: 32px;
  text-align: center;
  text-align-last: center;
  margin: 0 0.5em;
  color: $color-secondary-black;
}

.reservation-result {
  padding: 35px 0;

  &.theme-vip-member {
    background: $color-white;
  }
}

.result-title {
  color: $color-skm-red;
  margin-bottom: 0.33em;
}

.result-message {
  color: $color-secondary-black;
  margin-bottom: 2.5em;
}

.restaurant-detail-content {
  textarea,
  input {
    font-size: 16px;
  }
}

.theme-vip-member .restaurant-detail-content {
  background: $color-gold-100;
}

.booking-phone-desc {
  display: inline-block;
  margin-top: 10px;
  font-size: 14px;
}

.booking-form-label {
  margin-bottom: 20px;

  &:before {
    content: "";
    display: inline-block;
    width: 10px;
    height: 10px;
    background-image: url("/static/images/ic-vip-dot.png");
    background-size: 10px 10px;
    margin-right: 0.5em;
  }
}

.requirement-item-desc {
  display: inline-block;
  margin-top: 20px;
}

.edit-button {
  color: $color-skm-red;
  display: block;
  text-align: right;
  width: 100%;
  padding: 0;
  border: none;
  background: none;
  font-size: 14px;
  vertical-align: middle;
  cursor: pointer;

  &:before {
    content: "";
    display: inline-block;
    width: 14px;
    height: 14px;
    background-image: url("/static/images/ic-form-edit.svg");
    margin-right: 0.3em;
    vertical-align: middle;
  }
}

.account-info-container {
  margin-bottom: 22px;

  @include media-breakpoint-up(md) {
    margin-left: -20px;
  }
}
</style>
